// src/components/ImageSlider.tsx
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import React, { useEffect, useRef, useState } from "react";
import { View, StyleSheet, ScrollView, Dimensions, Text, Image } from "react-native";
var DummyImage = [
    "https://img.freepik.com/free-photo/photocomposition-horizontal-shopping-banner-with-woman-big-smartphone_23-2151201773.jpg",
    "https://img.freepik.com/free-photo/full-shot-woman-online-fashion-shopping_23-2150460083.jpg",
    "https://img.freepik.com/free-photo/online-fashion-shopping-with-laptop_23-2150400632.jpg"
];
var Slider = function(param) {
    var images = param.images, dotColor = param.dotColor, inActiveDotColor = param.inActiveDotColor, delay = param.delay, infinite = param.infinite, containerStyle = param.containerStyle, contentStyle = param.contentStyle;
    var width = Dimensions.get("window").width;
    var height = width * 0.55;
    var _useState = _sliced_to_array(useState(0), 2), active = _useState[0], setActive = _useState[1];
    var scrollViewRef = useRef(null);
    var _useState1 = _sliced_to_array(useState([]), 2), Images = _useState1[0], setimages = _useState1[1];
    var onScrollChange = function(param) {
        var nativeEvent = param.nativeEvent;
        var slide = Math.ceil(nativeEvent.contentOffset.x / nativeEvent.layoutMeasurement.width);
        if (slide !== active) {
            setActive(slide);
        }
    };
    if (infinite === true) {
        useEffect(function() {
            var interval = setInterval(function() {
                if (active < Images.length - 1) {
                    var _scrollViewRef_current;
                    (_scrollViewRef_current = scrollViewRef.current) === null || _scrollViewRef_current === void 0 ? void 0 : _scrollViewRef_current.scrollTo({
                        x: (active + 1) * width,
                        animated: true
                    });
                    setActive(active + 1);
                } else {
                    var _scrollViewRef_current1;
                    (_scrollViewRef_current1 = scrollViewRef.current) === null || _scrollViewRef_current1 === void 0 ? void 0 : _scrollViewRef_current1.scrollTo({
                        x: 0,
                        animated: true
                    });
                    setActive(0);
                }
            }, delay);
            return function() {
                return clearInterval(interval);
            };
        }, [
            active,
            Images.length
        ]);
    }
    useEffect(function() {
        if (images === void 0) {
            setimages(DummyImage);
        }
        return function() {};
    }, []);
    return /* @__PURE__ */ React.createElement(View, null, /* @__PURE__ */ React.createElement(ScrollView, {
        pagingEnabled: true,
        horizontal: true,
        onScroll: onScrollChange,
        showsHorizontalScrollIndicator: false,
        style: [
            {
                width: width,
                height: height
            },
            containerStyle ? containerStyle : null
        ],
        ref: scrollViewRef,
        scrollEventThrottle: 16
    }, Images.map(function(i, index) {
        return /* @__PURE__ */ React.createElement(Image, {
            style: [
                {
                    width: width,
                    height: height,
                    resizeMode: "cover"
                },
                contentStyle ? contentStyle : null
            ],
            key: index,
            source: {
                uri: i
            }
        });
    })), /* @__PURE__ */ React.createElement(View, {
        style: styles.pagination
    }, Images.map(function(i, k) {
        return /* @__PURE__ */ React.createElement(Text, {
            key: k,
            style: k == active ? {
                fontSize: 40,
                color: dotColor
            } : {
                fontSize: 40,
                color: inActiveDotColor
            }
        }, "•");
    })));
};
var styles = StyleSheet.create({
    pagination: {
        flexDirection: "row",
        position: "absolute",
        bottom: -15,
        alignSelf: "center"
    }
});
var ImageSlider_default = Slider;
export { ImageSlider_default as ImageSlider };
